from odoo import models, fields, api, _
from odoo.exceptions import UserError

class ResUsers(models.Model):
    _inherit = 'res.users'

    warehouse_id = fields.Many2one('warehouse.helpdesk','Sucursal')
    #warehouse_ids = fields.Many2many(
    #    string='Sucursales Permitidas',
    #    comodel_name='warehouse.helpdesk',
    #    relation='warehouse_helpdesk_res_users_rel'
    #    )
    name = fields.Char('Name',store=True)
    comp_morsa = fields.Selection([
       ('gmm','Grupo Morsa de México'),
        ('energy','Energy Parts'),
        ('tracto','Tracto Unión'),
        ('refago','RefaGO'),
    ],'Empresa')
    is_erp_user = fields.Boolean('Es usuario de ERP')
    is_911_user = fields.Boolean('Es usuario de 911')
    #partner_id = fields.Many2one('res.partner',required=False, )
    is_support_user = fields.Boolean('Es usuario Soporte')



    @api.model
    def create(self,vals):
        res = super(ResUsers, self).create(vals)
        if res.partner_id and not res.partner_id.email:
            res.partner_id.sudo().write({
                'email':res.login
            })
        return res
    
    def write(self,vals):
        res = super(ResUsers, self).write(vals)
        if self.partner_id and not self.partner_id.email or self.partner_id.email != self.login:
            self.partner_id.sudo().write({
                'email':self.login
            })
        return res
    